unit WMain;

{$mode objfpc}{$H+}

interface

uses
  windows, Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  StdCtrls, LMessages;

const
  LM_TOUCH = LM_USER + 1;

  TABLET_CONFIG_NONE 		= $00000000;
  NID_INTEGRATED_TOUCH 	= $00000001;
  NID_EXTERNAL_TOUCH 		= $00000002;
  NID_INTEGRATED_PEN	 	= $00000004;
  NID_EXTERNAL_PEN 			= $00000008;
  NID_MULTI_INPUT 			= $00000040;
  NID_READY 						= $00000080;

  TWF_FINETOUCH 				= $00000001;
  TWF_WANTPALM 					= $00000002;

  WM_TOUCH 							= $00000240;
	WM_POINTERUPDATE			= $00000245;
  WM_POINTERDOWN				= $00000246;
  WM_POINTERUP					= $00000247;

function RegisterTouchWindow(h: HWND; ulFlags: ULONG): BOOL; stdcall; external user32;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    FPrevWndProc: Windows.WNDPROC;
  public
    procedure WMContextMenu(var TheMessage: TLMessage); message WM_CONTEXTMENU;
    procedure WMTouch(var TheMessage: TLMessage); message LM_TOUCH;
    procedure WMPointerdown(var TheMessage: TLMessage); message WM_POINTERDOWN;
    procedure WndProc(var TheMessage: TLMessage); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function TForm1_SubClassWndProc (AWnd: HWND; uMsg: UINT; wParam: WParam; lParam: LParam): LRESULT; stdcall;
begin
  case uMsg of
    WM_TOUCH:
      Result := SendMessage(Form1.Handle, LM_TOUCH, wParam, lParam);
    else
      Result := CallWindowProc(Form1.FPrevWndProc, AWnd, uMsg, wParam, lParam);
  end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPrevWndProc:=Windows.WNDPROC(SetWindowLongPtr(Handle,GWL_WNDPROC,PtrInt(@TForm1_SubClassWndProc)));
  if not RegisterTouchWindow(Handle, TWF_WANTPALM) then ShowMessage('Error: ' + IntToStr(GetLastError));
end;

procedure TForm1.WMContextMenu(var TheMessage: TLMessage);
begin
  ShowMessage('ContextMenu');
end;

procedure TForm1.WMTouch(var TheMessage: TLMessage);
begin
  ShowMessage('Touched');
end;

procedure TForm1.WMPointerdown(var TheMessage: TLMessage);
begin
  ShowMessage('Pointer down');
end;

procedure TForm1.WndProc(var TheMessage: TLMessage);
begin
  if (TheMessage.msg <> $20) and (TheMessage.msg <> $84) and (TheMessage.msg <> $B012) then begin
    WriteLn('0x' + IntToHex(TheMessage.msg, 8));
  end;
  inherited WndProc(TheMessage);
end;

end.

